#!/usr/bin/perl -w
###############################################################################
#    Copyright (C) 2004 by Eric Gerbier
#    Bug reports to: gerbier@users.sourceforge.net
#    $Id: Makefile.pl,v 1.2 2004/04/05 10:44:08 gerbier Exp $
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#################################################################################
# a perl script to check for module requirements, needed by afick
#################################################################################

use strict;

#################################################################################
sub check_module($) {
	my $fic = shift (@_);

	open( PROG, '<', $fic ) or warn "impossible to open $fic : $!\n";

	my $nb_ko = 0;
	while (<PROG>) {

		# search for 'use' commands
		# I suppose "require" are used withh eval
		if ( $_ =~ m/^use\s+([^\s;(]*)/ ) {
			my $module = $1;

			$module =~ s/::/\//;

			# now test
			eval { require $module . '.pm' };
			if ($@) {
				print "WARNING : module $module not found : $@\n";
				$nb_ko++;
			}

		}
	}
	close(PROG);

	if ( $nb_ko == 0 ) {
		print "FINE : all module founds to install $fic\n";
		return 1;
	}
	else {
		warn
"WARNING : can not install $fic : some necessary modules are missing\n";
		return 0;
	}
}
#################################################################################

# first : check for needed modules
# ################################
if ( check_module('afick.pl') ) {
	if ( check_module('afick-tk.pl') ) {

		# all is ok
		rename( 'Makefile.in', 'makefile' );
		print "now you can run 'make all' to install console and gui\n";
	}
	else {

		# gui can be installed
		rename( 'Makefile.in', 'makefile' );
		print "now you can run 'make install' to install console tool\n";
	}
}
else {

	# no install possible
	print "you can not install any afick component\n";
}
